﻿Option Strict On
Imports System.Net.Http
'Imports System.Text

' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
''' 
Public Class ProductInfo
    Property 画像 As String
    Property 商品名 As String
    Property 価格 As String
    Property サイト As String
End Class
Public NotInheritable Class MainPage
    Inherits Page

    ''' <summary>
    ''' このページがフレームに表示されるときに呼び出されます。
    ''' </summary>
    ''' <param name="e">このページにどのように到達したかを説明するイベント データ。Parameter 
    ''' プロパティは、通常、ページを構成するために使用します。</param>
    ''' 
    Const AppID As String = "72844c678207217b73926f1740e46405"
    Dim xmldoc As XElement
    Dim selectGenreID As String
    Protected Overrides Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        xmldoc = XElement.Load("RakutenGenreId.xml")
        Dim titleList As New List(Of String)

        For Each result In From c In xmldoc.Descendants("genreId") Select c
            titleList.Add(result.Attribute("title").Value)
        Next
        ListBox1.ItemsSource = titleList
    End Sub

    Private Sub okButton_Click(sender As Object, e As RoutedEventArgs) Handles okButton.Click
        Dim myKeyWord As String = Uri.EscapeDataString(searchTextBox.Text)
        Dim mySort As String = Uri.EscapeDataString("+itemPrice")
        'Dim myUri As String = String.Format("http://api.rakuten.co.jp/rws/3.0/rest?developerId={0}&operation=ItemSearch&version=2010-09-15&keyword={1}&sort={2}&genreId={3}", AppID, myKeyWord, mySort, selectGenreID)
        Dim myUri As String = String.Format("https://app.rakuten.co.jp/services/api/IchibaItem/Search/20120723?applicationId={0}&keyword={1}&sort={2}&genreId={3}&format=xml", AppID, myKeyWord, mySort, selectGenreID)
        Dim myHttpClient As New HttpClient
        Dim myResponse = myHttpClient.GetStringAsync(New Uri(myUri, UriKind.Absolute))
        Dim myContent = myResponse.Result
        Dim xmldoc As XElement = XElement.Parse(myContent)

        Dim myProductInfo As New List(Of ProductInfo)
        For Each result In From c In xmldoc.Descendants("Item") Select c
            With myProductInfo
                .Add(New ProductInfo With {.画像 = result.Element("mediumImageUrls").Value,
                                        .商品名 = result.Element("itemName").Value,
                                        .価格 = String.Format("{0:n0}円", Integer.Parse(result.Element("itemPrice").Value)),
                                        .サイト = result.Element("itemUrl").Value})
            End With
        Next
        resultListBox.ItemsSource = myProductInfo
    End Sub

    Private Sub ListBox1_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles ListBox1.SelectionChanged
        selectGenreID = xmldoc.Descendants("genreId")(ListBox1.SelectedIndex).Value
        okButton.IsEnabled = True
    End Sub

    Private Sub resultListBox_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles resultListBox.SelectionChanged
        Try
            Dim mySite As String = DirectCast(resultListBox.SelectedItem, ProductInfo).サイト
            WebBrowser1.Navigate(New Uri(mySite, UriKind.Absolute))
        Catch
            Exit Sub
        End Try
    End Sub

End Class
